﻿from tkinter import *
#global Ctab
#Ctab=['red','yellow','#000077']
#■閉多角形の描画
def drawCell(XX,YY,ZZ,W):
    X  = XX + YY
    Y  = ZZ + XX
    DL = W / 3
    X0 = X
    Y0 = Y
    X1 = X  + DL
    Y1 = Y  + DL
    X2 = X  + W
    Y2 = Y  + W
    X3 = X2 + DL
    Y3 = Y2 + DL
    canvas.create_rectangle(200+X0, 300-Y0, 200+X2, 300-Y2,fill='red'    , outline='red',tag="Rect")
    canvas.create_rectangle(200+X1, 300-Y2, 200+X3, 300-Y3,fill='yellow' , outline='',tag="Rect")
    canvas.create_rectangle(200+X2, 300-Y1, 200+X3, 300-Y2,fill='#000077', outline='#000077',tag="Rect")
#■描画
def menger(X,Y,Z,L):
    if L<7: # Lが小さいとき描画
        drawCell(X,Y,Z,L)
    else:
        LL = L / 3
        # 最も奥側を描く　　　　　# 　　■■■　　　　　
        XX = X                    #     ■　■
        YY = Y                    #     ■■■
        for j in range(1,4):          
            ZZ=Z
            for k in range(1,4):
                if j!=2 or k!=2:  # 中央を除いて描く
                    menger(XX,YY,ZZ,LL)
                ZZ+=LL
            YY+=LL
        # 中央を描く              #     ■　■
        XX -= LL/3                #    
        YY = Y                    #     ■　■
        for j in range(1,4):           
            ZZ=Z
            for k in range(1,4):       
                if j!=2 and k!=2: # 端だけを描く(十字に空く)
                    menger(XX,YY,ZZ,LL)
                ZZ+=LL
            YY+=LL
        # 最も手前を描く　　　　　# 　　■■■　　　　　
        XX -= LL/3                #     ■　■
        YY = Y                    #     ■■■
        for j in range(1,4):          
            ZZ=Z
            for k in range(1,4):
                if j!=2 or k!=2:  # 中央を除いて描く
                    menger(XX,YY,ZZ,LL)
                ZZ+=LL
            YY+=LL
    # 途中経過を見たいときは以下の注釈を外す
    #tk.update()
        
#■メイン処理
tk=Tk()
tk.title("Menger's Sponge")
canvas=Canvas(tk, width=500,height=500)
canvas.pack()
canvas.delete("Rect")
menger(0,0,0,pow(3,5))
tk.update()
tk.mainloop()    




    
